##############################################################################
#
#	Makefile -- Master makefile for all libraries.
#

.EXPORT_ALL_VARIABLES:

##############################################################################
#
# Include architecture specific build rules.
#

ifndef ROOTDIR
ROOTDIR=$(PWD)/..
endif

UCLINUX_BUILD_LIB=1
HOST_NCPU?=1
-include $(LINUX_CONFIG)
-include $(CONFIG_CONFIG)
-include $(ARCH_CONFIG)
-include $(MODULES_CONFIG)

##############################################################################
#
# always build these dir_
#
dir_1_y  = $(LIBCDIR)
dir_1_n  =
dir_1_   =

ifeq ($(LIBCDIR),libc)
dir_2_y += libm libcrypt_old
dir_2_n +=
dir_2_  +=
endif

dir_2_$(CONFIG_LIB_UCLIBCPP)     += uClibc++

#
# and build these if someone needs them
#
dir_3_$(CONFIG_LIB_FLEX)         += flex
dir_3_$(CONFIG_LIB_LIBSSL)       += libssl
dir_3_$(CONFIG_LIB_LIBGMP)       += libgmp
dir_3_$(CONFIG_LIB_LIBG)         += libg
dir_3_$(CONFIG_LIB_LIBPAM)       += libpam
dir_3_$(CONFIG_LIB_LIBPCAP)      += libpcap
dir_3_$(CONFIG_LIB_ZLIB)         += zlib
dir_3_$(CONFIG_LIB_LIBBZ2)       += libbzip2
dir_3_$(CONFIG_LIB_LIBATM)       += libatm
dir_3_$(CONFIG_LIB_LIBNET)       += Libnet
dir_3_$(CONFIG_LIB_LIBNETOLD)    += libnet
dir_3_$(CONFIG_LIB_LIBJPEG)      += libjpeg
dir_3_$(CONFIG_LIB_LIBUPNP)      += libupnp
dir_3_$(CONFIG_LIB_STLPORT)      += STLport
dir_3_$(CONFIG_LIB_EXPAT)        += expat
dir_3_$(CONFIG_LIB_LIBDAEMON)    += libdaemon
dir_3_$(CONFIG_LIB_LIBCAP)       += libcap
dir_3_$(CONFIG_LIB_LIBKRB5)	 += libkrb5
dir_4_$(CONFIG_LIB_CYRUSSASL)	 += libcyrussasl
dir_5_$(CONFIG_LIB_LIBLDAP)      += libldap
dir_3_$(CONFIG_LIB_TINYTCL)      += ../user/tinytcl
dir_3_$(CONFIG_LIB_LIBCCMALLOC)  += libccmalloc
dir_3_$(CONFIG_LIB_ARES)         += libares
dir_3_$(CONFIG_LIB_LIBIDN)       += libidn
dir_3_$(CONFIG_LIB_LIBCRYPT_OLD) += libcrypt_old
dir_3_$(CONFIG_LIB_LIBLZO)       += lzo
dir_3_$(CONFIG_LIB_LIBPCRE)      += pcre
dir_3_$(CONFIG_LIB_LIBLZMA)      += liblzma
dir_3_$(CONFIG_LIB_OSIP2)        += osip2
dir_3_$(CONFIG_LIB_LIBEFENCE)    += libefence
dir_2_$(CONFIG_LIB_TERMCAP)      += termcap
dir_3_$(CONFIG_LIB_LIBSYSFS)     += sysfsutils
dir_3_$(CONFIG_LIB_LIBNL)        += libnl
dir_3_$(CONFIG_USER_TCL_LIBTCL)  += ../user/tcl
dir_3_$(CONFIG_LIB_LIBIBERTY)    += libiberty
dir_3_$(CONFIG_LIB_BFD)          += bfd
dir_3_$(CONFIG_LIB_POPT)         += popt
dir_3_$(CONFIG_LIB_LIBJUDY)      += libjudy
dir_3_$(CONFIG_LIB_CLASSPATH)    += classpath
dir_3_$(CONFIG_LIB_LIBFFI)       += libffi
dir_3_$(CONFIG_LIB_BITVECTOR)    += bitvector
dir_3_$(CONFIG_LIB_NCURSES_FORCE)+= ncurses
dir_3_$(CONFIG_LIB_NCURSES)      += ncurses


# See Kconfig for the dependencies
dir_4_$(CONFIG_LIB_LIBPNG)       += libpng
dir_4_$(CONFIG_LIB_LIBCURL)      += libcurl
dir_4_$(CONFIG_LIB_LIBXML2)      += libxml2

dir_3_$(CONFIG_LIB_NFNETLINK)    += libnfnetlink
dir_4_$(CONFIG_LIB_NETFILTER_LOG)+= libnetfilter_log
dir_4_$(CONFIG_LIB_NETFILTER_CONNTRACK) += libnetfilter_conntrack

dir_4_$(CONFIG_LIB_PWLIB)        += pwlib
dir_5_$(CONFIG_LIB_LIBOPENH323)  += libopenh323

dir_4_$(CONFIG_LIB_MICROSUPPORT) += microsupport
dir_5_$(CONFIG_LIB_AVDECC)   += avdecc

#
# dir 6, 7 and 8 reserved for Makefile.local
#
-include Makefile.local

# And build libraries in the prop directory last (if it exists)
dir_9_y += $(wildcard $(ROOTDIR)/prop)

# dir_y is used for Makefile.auto
include Makefile.auto

DIRS_NUM = 1 2 3 4 5 6 7 8 9
DIRS_y   = $(foreach n,$(DIRS_NUM),$(sort $(dir_$(n)_y))) $(sort $(dir_y))
DIRS_all = $(foreach n,$(DIRS_NUM),$(sort $(dir_$(n)_y) $(dir_$(n)_n) $(dir_$(n)_))) $(sort $(dir_y) $(dir_n) $(dir_))

##############################################################################

all:
	$(MAKE) -j1 -C ../include                 || exit $$?
	[ -z "$(dir_1_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_1_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_2_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_2_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_3_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_3_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_4_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_4_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_5_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_5_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_6_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_6_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_7_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_7_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_8_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_8_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_9_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_9_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?
	[ -z "$(dir_y)" ] ||\
		$(MAKE) -j$(HOST_NCPU) $(sort $(dir_y)) || exit $$?
	$(MAKE) -j1 -C ../include
	$(MAKE) make_links                        || exit $$?

# the actual dir target
.PHONY: $(DIRS_y)
$(DIRS_y):
	[ ! -d "$@" ] || ( touch $@/.sgbuilt_lib && $(MAKE) $(SUBDIR_SMP_BUILD) -C $@ ) || exit $$?

%_only:
	touch $(@:_only=)/.sgbuilt_lib && $(MAKE) -j$(HOST_NCPU) $(SUBDIR_SMP_BUILD) -C $(@:_only=)

%_clean:
	$(MAKE) -j1 -C $(@:_clean=) clean; rm -f $(@:_clean=)/.sgbuilt_lib; true

%_romfs:
	$(MAKE) $(SUBDIR_SMP_BUILD) -C $(@:_romfs=) romfs

##############################################################################

# Not the best place to install these symlinks, but it will do for now
romfs:
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -s config/passwd /etc/passwd
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -s config/group /etc/group
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -s config/mtab /etc/mtab
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -s config/fstab /etc/fstab
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -s config/hosts /etc/hosts
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -s config/resolv.conf /etc/resolv.conf
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -e CONFIG_USER_BASH_BASH -s config/profile /etc/profile
	$(ROMFSINST) -e CONFIG_USER_FLATFSD_FLATFSD -e CONFIG_USER_TINYLOGIN_SHADOWPASSWDS -s config/shadow /etc/shadow
	for i in $(DIRS_y) ; do \
		[ ! -d $$i ] || $(MAKE) $(SUBDIR_SMP_BUILD) -C $$i romfs || exit $$? ; \
	done

##############################################################################

clean: clean_links
	rm -f *.a
	-for i in $(DIRS_all); do \
		if [ -f $$i/.sgbuilt_lib ]; then \
			$(MAKE) -C $$i clean ; \
			rm -f $$i/.sgbuilt_lib; \
		fi; \
	done

##############################################################################
#
# The libs we link into this directory
#
#
LINKLIBS=\
    $(ROOTDIR)/lib/microsupport/tmp-target/build/lib/libmicrosupport.a \
    $(ROOTDIR)/lib/avdecc/tmp-target/build/lib/libavdecc.a \
	$(ROOTDIR)/lib/libxml2/build/.libs/libxml2.so \
	$(ROOTDIR)/lib/libjpeg/*.a \
	$(ROOTDIR)/lib/libpng/*.a \
	$(ROOTDIR)/lib/libm/*.a \
	$(ROOTDIR)/lib/ncurses/*.a \
	$(ROOTDIR)/lib/libatm/src/lib/.libs/*.a \
	$(ROOTDIR)/lib/libpam/build/libpam*/.libs/*.a \
	$(ROOTDIR)/lib/libpam/build/libpam*/.libs/*.so \
	$(ROOTDIR)/lib/libpcap/build/*.a \
	$(ROOTDIR)/lib/libnet/*.a \
	$(ROOTDIR)/lib/liblzma/*.a \
	$(ROOTDIR)/lib/libares/build/*.a \
	$(ROOTDIR)/lib/libidn/build/lib/.libs/libidn.a \
	$(ROOTDIR)/lib/libcurl/build/lib/.libs/libcurl.a \
	$(ROOTDIR)/lib/libcurl/build/lib/.libs/libcurl.so \
	$(ROOTDIR)/lib/libjudy/src/obj/.libs/libJudy.a \
	$(ROOTDIR)/lib/libjudy/src/obj/.libs/libJudy.so \
	$(ROOTDIR)/lib/libssl/build/*.so* \
	$(ROOTDIR)/lib/libssl/build/*.a \
	$(ROOTDIR)/lib/zlib/libz.a* \
	$(ROOTDIR)/lib/zlib/libz.so* \
	$(ROOTDIR)/lib/libbzip2/libbz2.a* \
	$(ROOTDIR)/lib/libbzip2/libbz2.so* \
	$(ROOTDIR)/lib/libatm/src/lib/*.so* $(ROOTDIR)/lib/libatm/src/lib/*.a \
	$(ROOTDIR)/lib/libcrypt_old/libcrypt_old.a \
	$(ROOTDIR)/lib/libldap/builddir/libraries/libldap/.libs/*.a \
	$(ROOTDIR)/lib/libldap/builddir/libraries/liblber/.libs/*.a \
	$(ROOTDIR)/lib/pcre/builddir/.libs/*.a \
	$(ROOTDIR)/lib/bitvector/*.so \
	$(ROOTDIR)/lib/libkrb5/build/lib/*.so \
	$(ROOTDIR)/lib/libcyrussasl/build/lib/.libs/*.so \
	$(ROOTDIR)/prop/acld/libacld.a \
	$(ROOTDIR)/prop/libsnapgear++/*.a $(ROOTDIR)/prop/libsnapgear++/*.so* \
	$(ROOTDIR)/prop/libsnapgear/*.a $(ROOTDIR)/prop/libsnapgear/*.so* \
	$(ROOTDIR)/user/tinytcl/*.a $(ROOTDIR)/user/tinytcl/*.a* \
	$(ROOTDIR)/user/tinytcl/*.a $(ROOTDIR)/user/tinytcl/*.so* \
	$(ROOTDIR)/user/tcl/build/*.a \
	$(ROOTDIR)/prop/config/*.a $(ROOTDIR)/prop/config/*.so* \
	$(ROOTDIR)/prop/uberconfig/*.a $(ROOTDIR)/prop/uberconfig/*.so* \
	$(ROOTDIR)/prop/gccmapping/*.a $(ROOTDIR)/prop/gccmapping/*.so* \
	$(ROOTDIR)/lib/expat/*.a $(ROOTDIR)/lib/expat/*.so* \
	$(ROOTDIR)/lib/libupnp/upnp/bin/*.so* $(ROOTDIR)/lib/adns/src/libadns.a \
	$(ROOTDIR)/lib/flex/build/*.a \
	$(ROOTDIR)/lib/libgmp/build/install/lib/*.a \
	$(ROOTDIR)/lib/lzo/build/src/.libs/*.a \
	$(ROOTDIR)/lib/osip2/build/install/lib/*.a \
	$(ROOTDIR)/prop/libsscep/*.a \
	$(ROOTDIR)/prop/statsd/*.a \
	$(ROOTDIR)/prop/statsd/*.so \
	$(ROOTDIR)/lib/libefence/*.a \
	$(ROOTDIR)/lib/termcap/*.a \
	$(ROOTDIR)/lib/sysfsutils/build/lib/.libs/*.a \
	$(ROOTDIR)/lib/libnl/lib/*.a* \
	$(ROOTDIR)/lib/libnl/lib/*.so* \
	$(ROOTDIR)/lib/libnfnetlink/build/src/.libs/*.a* \
	$(ROOTDIR)/lib/libnfnetlink/build/src/.libs/*.so* \
	$(ROOTDIR)/lib/libnfnetlink/build/libnfnetlink.pc \
	$(ROOTDIR)/lib/libnetfilter_conntrack/build/src/.libs/*.a* \
	$(ROOTDIR)/lib/libnetfilter_conntrack/build/src/.libs/*.so* \
	$(ROOTDIR)/lib/libnetfilter_conntrack/build/libnetfilter_conntrack.pc \
	$(ROOTDIR)/lib/libnetfilter_log/build/src/.libs/*.a* \
	$(ROOTDIR)/lib/libnetfilter_log/build/src/.libs/*.so* \
	$(ROOTDIR)/lib/libnetfilter_log/build/libnetfilter_log.pc \
	$(ROOTDIR)/lib/libiberty/build/*.a \
	$(ROOTDIR)/lib/bfd/build/*.a \
	$(ROOTDIR)/lib/popt/build/.libs/*.a \
	$(ROOTDIR)/lib/STLport/lib/*.a \
	$(ROOTDIR)/lib/STLport/lib/*.so \
	$(ROOTDIR)/lib/libffi/install/lib/*.a \
	$(ROOTDIR)/lib/libffi/install/lib/*.la \
	$(ROOTDIR)/lib/libffi/install/lib/pkgconfig/*.pc \
	$(ROOTDIR)/prop/libtrustedsource/librep/librep.so* \
	$(STAGEDIR)/usr/lib/*.a

# The dynamic linker library needs to be linked into lib via a different name
LD_LIB = $(ROOTDIR)/lib/uClibc/lib/ld-uClibc-0.9.29.so
LD_LIB_DEST = $(ROOTDIR)/lib/ld-linux.so.2

##############################################################################

make_links: clean_links
	@echo "Making symlinks in lib/"
	@for p in $(LINKLIBS); do \
		for i in $$p; do \
			[ ! -e "$$i" ] && continue; \
			[ "`basename $$i`" = CVS ] && continue; \
			[ -L "./`basename $$i`" ] && continue; \
			ln -s $$i .; \
		done ; \
	done	
	@ln -sf $(LD_LIB) $(LD_LIB_DEST)		

clean_links:
	@-for i in *; do \
		[ "$$i" = "Makefile" ] && continue; \
		[ "$$i" = "Kconfig" ] && continue; \
		[ -L "$$i" ] || continue ; \
		case "`file -L $$i`" in \
		*directory*) ;; \
		*) rm -f $$i ;; \
		esac ; \
	done

##############################################################################

prune:
	-for i in $(DIRS_all) ; do \
		found=0; \
		for j in $(sort $(DIRS_y)) ; do \
			if [ $$i = $$j ]; then \
				found=1; \
			fi; \
		done; \
		if [ $$found = 0 ]; then \
			rm -fr $$i; \
		fi; \
	done

##############################################################################
